#include <stm32f0xx.h>
#include <gpio.hpp>
#include <uart-gpio.hpp>
#include <uart.hpp>
using namespace stm32f072xb;
// https://www.st.com/resource/en/reference_manual/dm00031936-stm32f0x1stm32f0x2stm32f0x8-advanced-armbased-32bit-mcus-stmicroelectronics.pdf
// https://www.st.com/resource/en/datasheet/stm32f072c8.pdf

int main() {
	AbstractUartInit uartInit;
	uartInit.wordLength = WordLength::HEIGHT_BITS;
	uartInit.stopBits = StopBits::ONE_BIT;
	uartInit.baudRate = 9600;
	UartGpio<UartRegister::UART2, UartGpioType::RX, Port::A> rxGpio;
	UartGpio<UartRegister::UART2, UartGpioType::TX, Port::A> txGpio;

	Uart<UartRegister::UART2, Port::A> uartTxRx(uartInit, txGpio, rxGpio);
	while (true) {
		uint8_t word = uartTxRx.readWord();
		uartTxRx.writeWord(word);
	}
	return 0;
}
